﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Netcached.Hash
{
    class HashAlgorithm
    {
        public static ulong HashFNV1a64bits(byte[] bytes)
        {
            const ulong fnv64Offset = 14695981039346656037;
            const ulong fnv64Prime = 0x100000001b3;
            ulong hash = fnv64Offset;

            for (var i = 0; i < bytes.Length; i++)
            {
                hash = hash ^ bytes[i];
                hash *= fnv64Prime;
            }

            return hash;
        }

        public static uint HashFNV1a32bits(byte[] bytes)
        {
            uint hash = 2166136261;
            for (int i = 0; i < bytes.Length; i++)
            {
                hash = (hash ^ bytes[i]) * 16777619;
            }

            return hash;
        }
    }
}
