﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Netcached
{
    /// <summary>
    /// This class is used to define memcached servers for configuration purposes.
    /// </summary>
    [Serializable]
    public class ServerDefinition
    {
        public string Address { get; set; }
        public int Port { get; set; }
        public int SendReceiveTimeout { get; set; }

        public ServerDefinition(string address) : this(address, 11211)
        {
        }

        public ServerDefinition(string address, int port) : this(address, port, 2000)
        {
        }

        public ServerDefinition(string address, int port, int sendReceiveTimeout)
        {
            Address = address;
            Port = port;
            SendReceiveTimeout = sendReceiveTimeout;
        }
    }
}
